/*
 * $Id: fm2tfm.c,v 1.3 1991/09/23 18:41:24 trevor Exp $
 */

/* converts SGI Font Manager fonts to Trev's Font manager fonts */

#include <stdio.h>
#include <gl.h>
#include <device.h>
#include "fmclient.h"

#define ABS(x)		((x) < 0 ? -(x) : (x))
#define MAX(x,y)	((x) > (y) ? (x) : (y))
#define MIN(x,y)	((x) < (y) ? (x) : (y))

#define SAMPLE -1

#define NUMSAMPLE 10

static int sample[NUMSAMPLE+1] = { 
  0, 1, 7, 9, 11, 14, 17, 22, 35, 55, 71
};

long win;
fmfonthandle font1, font2;
int i, j, k, x, y, oysize, oxsize;
int xmaxscreen, ymaxscreen;
int thres,maxscalefactor;

FILE *tfp;

main(argc,argv)
int argc;
char *argv[];
{
 int doit();

 thres = SAMPLE;

 if(argc > 1) {
   thres = atoi(argv[1]);
   maxscalefactor = 72;
 }
 if(thres == SAMPLE) {
   maxscalefactor=NUMSAMPLE+1;
 }

 fminit();
 foreground();
 xmaxscreen = getgdesc(GD_XPMAX);
 ymaxscreen = getgdesc(GD_YPMAX);
 tfp = fopen("tfmlist","a");
 if(!tfp) {
   printf("Cannot open tfmlist for writing\n");
   exit(0);
 }
 doit(argv[2]);
 fclose(tfp);
 exit(0);
}

doit(str)
char *str;
{
 fmfontinfo fi;
 fmglyphinfo *gi;
 int xsize, ysize, maxxo, maxyo, minxo, minyo, w, h, x1, y1, x2, y2;
 int devheight, devwidth;
 float xmove, ymove;
 Colorindex *b;
 FILE *fp;
 long fppos;
 unsigned char scalesize;
 unsigned short word;
 int bit, first;
 
 oysize = -thres; oxsize = -thres;
 font1 = fmfindfont(str);
 fmsetfont(font1);
 first = 1;

 for(j = 1; j < maxscalefactor; j++) {

   if(thres == SAMPLE)
     scalesize = (unsigned char)sample[j];
   else
     scalesize = (unsigned char)j;

   font2 = fmscalefont(font1, (double)scalesize);
   fmsetfont(font2);
   fmgetfontinfo(font2, &fi);

   /* if this font is outside the threshold limits then treat it as a new
    * scale value
    */
   if((ABS((fi.ysize-oysize)) > thres) || (ABS((fi.xsize-oxsize)) > thres)) {

     if(thres == SAMPLE) {
       printf("Name: %-30s Scale:%2d Fixedwidth: %d Size:%3dx%d\n",
	      str,sample[j],fi.fixed_width,fi.xsize,fi.ysize);
     }
     else
     printf("Name: %-30s Scale:%2d Fixedwidth: %d Size:%3dx%d\n",
	    str,j,fi.fixed_width,fi.xsize,fi.ysize);
     
     fflush(stdout);

     xsize = 0; ysize = 0; maxxo = 0; maxyo = 0; minxo = 0; minyo = 0;
     xmove = 0; ymove = 0; 
     oysize = fi.ysize; oxsize = fi.xsize;

     /* allocate memory for the new font */
     gi = (fmglyphinfo *) calloc(fi.nglyphs,sizeof(fmglyphinfo));
     /* get info on all the new glyphs */
     fmgetwholemetrics(font2, gi);

     /*
      * special case for a space and non printable characters.
      * figure out number of pixels wide a space is and set 'xmove' to this
      * value. For some reason the SGI font manager sets this to 0 for some
      * fonts
      */
     if(gi[32].xmove == 0.0)
       gi[32].xmove = (float)fmgetchrwidth(font2, (unsigned char)32);

     /* for all the non-printable characters change them to spaces */
     for(i = 0; i < 32; i++) {
       gi[i].xsize = gi[32].xsize; gi[i].ysize = gi[32].ysize;
       gi[i].xorig = gi[32].xorig; gi[i].yorig = gi[32].yorig;
       gi[i].xmove = gi[32].xmove; gi[i].ymove = gi[32].ymove;
       gi[i].gtype = gi[32].gtype; gi[i].bitsdeep = gi[32].bitsdeep;
     }
     /* del symbol */
     gi[127].xsize = gi[32].xsize; gi[127].ysize = gi[32].ysize;
     gi[127].xorig = gi[32].xorig; gi[127].yorig = gi[32].yorig;
     gi[127].xmove = gi[32].xmove; gi[127].ymove = gi[32].ymove;
     gi[127].gtype = gi[32].gtype; gi[127].bitsdeep = gi[32].bitsdeep;

     /* figure out the max symbol sizes, to open the window to */
     for(i = 32; i < 127; i++) {
       xsize = MAX(xsize,gi[i].xsize); ysize = MAX(ysize,gi[i].ysize);
       maxxo = MAX(maxxo,gi[i].xorig); maxyo = MAX(maxyo,gi[i].yorig);
       minxo = MIN(minxo,gi[i].xorig); minyo = MIN(minyo,gi[i].yorig);
     }

     i = xsize + ABS(minxo);
     devwidth = maxxo+i;
     i = ysize + ABS(minyo);
     devheight = maxyo+i;

     if(first) {
       fprintf(tfp,"%s ", str);
       fflush(tfp);
       first = 0;
     }

     /* open the Fontname file */
     fp = fopen(str,"a");
     fppos = ftell(fp);
       
     /* write the current scalesize and offset to the tfmlist file */
     fwrite(&scalesize,sizeof(unsigned char),1,tfp);
     fflush(tfp);
     fwrite(&fppos,sizeof(long),1,tfp);
     fflush(tfp);
     fi.nglyphs = 128;

     /* write the fmfontinfo to the Fontname file */
     writefmfontinfo(fp, &fi);

     /* open the window to read the font bitmap from */
     prefposition(xmaxscreen-30-devwidth,xmaxscreen-30,
		  ymaxscreen-30-devheight,ymaxscreen-30);
     win = winopen("FM");
     cmode();
     gconfig();
     /* 
      * this is really wierd.. even if I say a 10 x 10 window it opens as
      * 51x10..
      */
     getsize(&devwidth, &devheight);
     i = xsize + ABS(minxo);
     i = MAX((devwidth-maxxo-1), i);
     k = ysize + ABS(minyo);
     ortho2(-maxxo, i, -maxyo, k);
#if 0
     printf("%d,%d\n",devwidth, devheight);
     printf("ortho2(%d,%d,%d,%d)\n",-maxxo, i, -maxyo, k);
#endif

     for(i = 0; i < 128; i++) {
       color(WHITE); clear();
#if DEBUG
       color(RED); pnt2i(0,0);
#endif
       color(BLACK); cmov2i(0,0);
       /* display charater on the window */
       fmoutchar(font2, (unsigned char)i);

       /* write the glyph info to the Fontname file */
       writefmglyphinfo(fp, &gi[i], i);

       w = gi[i].xsize; h = gi[i].ysize;
       if(h && w) {
	 b = (Colorindex *) malloc((w)*(h)*sizeof(Colorindex));
	 /* get the glyph bounding box */
	 x1 = maxxo - gi[i].xorig;
	 x2 = x1 + w - 1;
	 y1 = maxyo - gi[i].yorig;
	 y2 = y1 + h - 1;
	 rectread(x1, y1, x2, y2, b);
	 for(y = 0; y < w*h; y++) b[y] = b[y] & 0x00ff; /* clear high bits */
#if DEBUG
	 {
	   long t;
	   int m;
	   short val;
	   printf("Glyph info: %d,%c\n",i,(char)i);
	   printf("xsize: %d, ysize: %d\n",gi[i].xsize,gi[i].ysize);
	   printf("xorig: %d, yorig: %d\n",gi[i].xorig,gi[i].yorig);
	   printf("xmove: %f, ymove: %f\n",gi[i].xmove,gi[i].ymove);
	   printf("maxxo: %d, maxyo: %d\n",maxxo, maxyo);
	   printf("minxo: %d, minyo: %d\n",minxo, minyo);
	   printf("read from: %d,%d %d,%d\n",x1, y1, x2, y2);
	   prefsize(w+1,h+1);
	   t = winopen("t"); cmode(); gconfig();
	   color(WHITE); clear();
	   rectwrite(0,0,w-1,h-1,b);
	   color(GREEN); pnt2i(0,0); color(BLUE); pnt2i(w-1,h-1);
	/*   color(GREEN); recti(0,0,w,h);*/
	   qdevice(MIDDLEMOUSE);
	   qreset();
	   while((m = qread(&val)) != MIDDLEMOUSE);
	   winclose(t);
	 }
#endif	   
	 /* write raster data into straight GL rasterfont format */
	 for(y = 0; y < h; y++) {
	   word = 0;
	   bit = 16;
	   for(x = 0; x < w; x++) {
	     bit--;
	     if(b[(y*w)+x] == BLACK)
	        word = word | (0x01 << bit);
	     if(bit == 0) {
	       fwrite(&word, sizeof(unsigned short), 1, fp);
	       bit = 16;
	       word = 0;
	     }
	   }
	   if(bit != 16) /* write out last word in current line */
	   fwrite(&word, sizeof(unsigned short), 1, fp);
	 }
	 free(b);
       }
     }
     if(win)winclose(win);
     if(fp)fclose(fp);
     if(font2) fmfreefont(font2);
     if(gi) free(gi);
   }
 }

 scalesize = 0; /* write NULL end-of-font marker */
 fppos = 0;
 fwrite(&scalesize, sizeof(unsigned char), 1, tfp);
 fflush(tfp);
 fwrite(&fppos, sizeof(long), 1, tfp);
 fflush(tfp);
}

writefmfontinfo(fp, fi)
FILE *fp;
fmfontinfo *fi;
{
 register int i;

 /* write the font info to the file in binary format */
 fwrite(&fi -> printermatched, sizeof(long), 1, fp);
 fwrite(&fi -> reserved0, sizeof(long), 1, fp);
 fwrite(&fi -> matrix00, sizeof(double),1,fp);
 fwrite(&fi -> matrix01, sizeof(double),1,fp);
 fwrite(&fi -> matrix10, sizeof(double),1,fp);
 fwrite(&fi -> matrix11, sizeof(double),1,fp);
 fwrite(&fi -> type, sizeof(long), 1, fp);
 fwrite(&fi -> encoding, sizeof(long), 1, fp);
 fwrite(&fi -> fixed_width, sizeof(long), 1, fp);
 fwrite(&fi -> xorig, sizeof(long), 1, fp);
 fwrite(&fi -> yorig, sizeof(long), 1, fp);
 fwrite(&fi -> xsize, sizeof(long), 1, fp);
 fwrite(&fi -> ysize, sizeof(long), 1, fp);
 fwrite(&fi -> height, sizeof(long), 1, fp);
 fwrite(&fi -> nglyphs, sizeof(long), 1, fp);
 fwrite(&fi -> bitsdeep, sizeof(long), 1, fp);
 fwrite(&fi -> width, sizeof(long), 1, fp);
 fwrite(&fi -> resolution, sizeof(long), 1, fp);
 fwrite(&fi -> weight, sizeof(long), 1, fp);
 fwrite(&fi -> reserved1, sizeof(long), 1, fp);
 fwrite(&fi -> reserved2, sizeof(long), 1, fp);
 fwrite(&fi -> reserved3, sizeof(long), 1, fp);
 for(i = 0; i < 27; i++)
  fwrite(&fi -> padding[i], sizeof(long), 1, fp);
}

writefmglyphinfo(fp,gi,c)
FILE *fp;
fmglyphinfo *gi;
unsigned char c;
{
 /* write the glyph info to the file in ASCII format */
 fwrite(&c, sizeof(unsigned char), 1, fp);
 fwrite(&gi -> xsize, sizeof(long), 1, fp);
 fwrite(&gi -> ysize, sizeof(long), 1, fp);
 fwrite(&gi -> xorig, sizeof(long), 1, fp);
 fwrite(&gi -> yorig, sizeof(long), 1, fp);
 fwrite(&gi -> xmove, sizeof(float),1,fp);
 fwrite(&gi -> ymove, sizeof(float),1,fp);
 fwrite(&gi -> gtype, sizeof(long), 1, fp);
 fwrite(&gi -> bitsdeep, sizeof(long), 1, fp);
}
/* 
 * $Log: fm2tfm.c,v $
 * Revision 1.3  1991/09/23  18:41:24  trevor
 * - New (Compacted) font file format
 * - many bug fixes
 *
 * Revision 1.2  1991/09/11  19:23:57  trevor
 * added fix for missing spaces in some fonts
 *
 * Revision 1.1  1991/09/09  19:49:57  trevor
 * added variable screen size support
 *
 * Revision 1.0  1991/06/28  22:52:47  trevor
 * Initial checkin
 * 
 */ 
