/*
 * $Id: fm2tfm.c,v 1.3 1991/09/23 18:41:24 trevor Exp $
 */

#include <stdio.h>
#include <gl.h>
#include <device.h>
#include "fmclient.h"

#define ABS(x)		((x) < 0 ? -(x) : (x))
#define MAX(x,y)	((x) > (y) ? (x) : (y))
#define MIN(x,y)	((x) < (y) ? (x) : (y))

#define SAMPLE -1

#define NUMSAMPLE 10

static int sample[NUMSAMPLE+1] = { 
  0, 1, 7, 9, 11, 14, 17, 22, 35, 55, 71
};

long win;
fmfonthandle font1, font2;
int i, j, k, x, y, oysize, oxsize;
int xmaxscreen, ymaxscreen;
int thres,maxscalefactor;

FILE *tfp;

main(argc,argv)
int argc;
char *argv[];
{
 int doit();

 thres = SAMPLE;
 maxscalefactor=NUMSAMPLE+1;

 fminit();
 foreground();
 xmaxscreen = getgdesc(GD_XPMAX);
 ymaxscreen = getgdesc(GD_YPMAX);
 fmenumerate(doit);
 exit(0);
}

doit(str)
char *str;
{
 fmfontinfo fi;
 fmglyphinfo *gi;
 int xsize, ysize, maxxo, maxyo, minxo, minyo, w, h, x1, y1, x2, y2;
 int devheight, devwidth;
 float xmove, ymove;
 Colorindex *b;
 FILE *fp;
 long fppos;
 unsigned char scalesize;
 unsigned short word;
 int bit, first;
 
 oysize = -thres; oxsize = -thres;
 font1 = fmfindfont(str);
 fmsetfont(font1);
 first = 1;

 for(j = 1; j < maxscalefactor; j++) {

   /* for now set j to 2 to force scale factor of 7 */
   j = 2;
   if(thres == SAMPLE)
     scalesize = (unsigned char)sample[j];
   else
     scalesize = (unsigned char)j;

   font2 = fmscalefont(font1, (double)scalesize);
   fmsetfont(font2);
   fmgetfontinfo(font2, &fi);

   /* if this font is outside the threshold limits then treat it as a new
    * scale value
    */
   if((ABS((fi.ysize-oysize)) > thres) || (ABS((fi.xsize-oxsize)) > thres)) {

     if(thres == SAMPLE) {
       printf("Name: %-30s Scale:%2d Fixedwidth: %d Size:%3dx%d\n",
	      str,sample[j],fi.fixed_width,fi.xsize,fi.ysize);
     }
     else
     printf("Name: %-30s Scale:%2d Fixedwidth: %d Size:%3dx%d\n",
	    str,j,fi.fixed_width,fi.xsize,fi.ysize);
     fflush(stdout);

     xsize = 0; ysize = 0; maxxo = 0; maxyo = 0; minxo = 0; minyo = 0;
     xmove = 0; ymove = 0; 
     oysize = fi.ysize; oxsize = fi.xsize;

     /* allocate memory for the new font */
     gi = (fmglyphinfo *) calloc(fi.nglyphs,sizeof(fmglyphinfo));
     /* get info on all the new glyphs */
     fmgetwholemetrics(font2, gi);

     /* figure out the max symbol sizes, to open the window to */
     for(i = 32; i < 127; i++) {
       xsize = MAX(xsize,gi[i].xsize); ysize = MAX(ysize,gi[i].ysize);
       maxxo = MAX(maxxo,gi[i].xorig); maxyo = MAX(maxyo,gi[i].yorig);
       minxo = MIN(minxo,gi[i].xorig); minyo = MIN(minyo,gi[i].yorig);
     }

     i = xsize + ABS(minxo);
     devwidth = maxxo+i;
     i = ysize + ABS(minyo);
     devheight = maxyo+i;

     fi.nglyphs = 128;

     /* open the window to read the font bitmap from */
     prefposition(xmaxscreen-30-devwidth,xmaxscreen-30,
		  ymaxscreen-30-devheight,ymaxscreen-30);
     win = winopen("FM");
     cmode();
     gconfig();
     /* 
      * this is really wierd.. even if I say a 10 x 10 window it opens as
      * 51x10..
      */
     getsize(&devwidth, &devheight);
     i = xsize + ABS(minxo);
     i = MAX((devwidth-maxxo-1), i);
     k = ysize + ABS(minyo);
     ortho2(-maxxo, i, -maxyo, k);

     for(i = 33; i < 128; i++) {
       color(WHITE); clear();
#if DEBUG
       color(RED); pnt2i(0,0);
#endif
       color(BLACK); cmov2i(0,0);
       /* display charater on the window */
       fmoutchar(font2, (unsigned char)i);

       w = gi[i].xsize; h = gi[i].ysize;
       if(h && w) {
	 b = (Colorindex *) malloc((w)*(h)*sizeof(Colorindex));
	 /* get the glyph bounding box */
	 x1 = maxxo - gi[i].xorig;
	 x2 = x1 + w - 1;
	 y1 = maxyo - gi[i].yorig;
	 y2 = y1 + h - 1;
	 rectread(x1, y1, x2, y2, b);
	 for(y = 0; y < w*h; y++) b[y] = b[y] & 0x00ff; /* clear high bits */
#if DEBUG
	 {
	   long t;
	   int m;
	   short val;
	   printf("Glyph info: %d,%c\n",i,(char)i);
	   printf("xsize: %d, ysize: %d\n",gi[i].xsize,gi[i].ysize);
	   printf("xorig: %d, yorig: %d\n",gi[i].xorig,gi[i].yorig);
	   printf("xmove: %f, ymove: %f\n",gi[i].xmove,gi[i].ymove);
	   printf("gtype: %d, bitsd: %d\n",gi[i].gtype,gi[i].bitsdeep);
	   printf("maxxo: %d, maxyo: %d\n",maxxo, maxyo);
	   printf("minxo: %d, minyo: %d\n",minxo, minyo);
	   printf("read from: %d,%d %d,%d\n",x1, y1, x2, y2);
	   prefsize(w+1,h+1);
	   t = winopen("t"); cmode(); gconfig();
	   color(WHITE); clear();
	   rectwrite(0,0,w-1,h-1,b);
	   color(GREEN); pnt2i(0,0); color(BLUE); pnt2i(w-1,h-1);
	/*   color(GREEN); recti(0,0,w,h);*/
	   qdevice(MIDDLEMOUSE);
	   qreset();
	   while((m = qread(&val)) != MIDDLEMOUSE);
	   winclose(t);
	 }
#endif	   
	 free(b);
       }
     }
     if(win)winclose(win);
     if(fp)fclose(fp);
     if(font2) fmfreefont(font2);
     if(gi) free(gi);
   }
 }

}
