/*
 * $Id: tfm_support.c,v 1.1 1991/09/23 18:41:26 trevor Exp $
 */

/*
 * Trevor's Implementation of the SGI Font Manager for use on 
 * machines that do not have the Font Manager (ie IBM)
 */

 /* Fonts were generate from and SGI running FM and converted to tfm
  * (Trev's Font Manager) using fm2tfm.c
  */

#include <stdio.h>
#include "tfmclient.h"
#include "tfminternal.h"

extern tfm_struct tfm, *tfmtmp;

tfm_font *tfm_gentfmfont()
{
 tfm_font *dummy;

 dummy = (tfm_font *)malloc(sizeof(tfm_font));
 if(!dummy) {
   fprintf(stderr,"TFM: Not enough memory for font\n");
   return((tfm_font *)NULL);
 }
 dummy -> fontnum = 0;
 dummy -> fonthandle = 0;
 dummy -> fontname = NULL;
 dummy -> fontsize = 0.0;
 dummy -> realfontsize = 0.0;
 dummy -> references = 0;
 dummy -> rasters = NULL;
 dummy -> next = NULL;
 return(dummy);
}

tfm_freetfmfont(dummy)
tfm_font *dummy;
{
 if(!dummy) {
   return(1);
 }

 if(dummy -> fontname) {
   free(dummy -> fontname);
   dummy -> fontname = NULL;
 }
 if(dummy -> rasters) {
   free(dummy -> rasters);
   dummy -> rasters = NULL;
 }
 free(dummy);

 return(0);
}

tfm_loadfont(face, offset, sc, t)
char *face;
long *offset;
float *sc;
tfm_font *t;
{
 FILE *fp;
 int i, j, tmp, h, w;
 char fontname[256];
 short *stmp;

 tfm_getscale(face, sc, offset);
 tfm.numfonts++;
 t->fontnum = tfm.numfonts;
 t->fontname = (char *) malloc(strlen(face)+1);
 strcpy(t->fontname,face);
 t->fontsize = *sc;
 sprintf(fontname,"%s/%s",tfm.fontpath,t->fontname);
 fp = fopen(fontname,"r");
 if(!fp) {
   perror(fontname);
   return(0);
 }
 fseek(fp, *offset, SEEK_SET);
 tfm_readfmfontinfo(fp, &t->fontinfo);
 tmp = 0; t->w = 0; t->h = 0;
 for(i = 0; i < 128; i++) {
   tfm_readfmglyphinfo(fp,&t->fmchars[i]);
   w = t->fmchars[i].xsize;
   h = t->fmchars[i].ysize;
   if(h > t->h) t->h = h;
   if(w > t->w) t->w = w;
   t->chars[i].offset = tmp;
   t->chars[i].w = w;
   t->chars[i].h = h;
   t->chars[i].xoff = (-1 * t->fmchars[i].xorig);
   t->chars[i].yoff = (-1 * t->fmchars[i].yorig);
   t->chars[i].width = t->fmchars[i].xmove;
   if(h && w) {
     j = w/16 + ((w%16)?(1):(0)); /* number of words in a line */
     j *= h;
     if(t->rasters == NULL) {
       t->numshorts = j;
       t->rasters = (short *) malloc(sizeof(short) * t->numshorts);
     }
     else {
       t->numshorts += j;
       t->rasters = (short *) realloc(t->rasters,sizeof(short)*(t->numshorts));
     }
     fread(&t->rasters[tmp], sizeof(unsigned short), j, fp);
     tmp += j;
   } /* if */
 } /* for */
 fclose(fp);
 return(1);
}
   

tfm_readfmfontinfo(fp, fi)
FILE *fp;
fmfontinfo *fi;
{
 register int i;

 fread(&fi -> printermatched, sizeof(long), 1, fp);
 fread(&fi -> reserved0, sizeof(long), 1, fp);
 fread(&fi -> matrix00, sizeof(double), 1, fp);
 fread(&fi -> matrix01, sizeof(double), 1, fp);
 fread(&fi -> matrix10, sizeof(double), 1, fp);
 fread(&fi -> matrix11, sizeof(double), 1, fp);
 fread(&fi -> type, sizeof(long), 1, fp);
 fread(&fi -> encoding, sizeof(long), 1, fp);
 fread(&fi -> fixed_width, sizeof(long), 1, fp);
 fread(&fi -> xorig, sizeof(long), 1, fp);
 fread(&fi -> yorig, sizeof(long), 1, fp);
 fread(&fi -> xsize, sizeof(long), 1, fp);
 fread(&fi -> ysize, sizeof(long), 1, fp);
 fread(&fi -> height, sizeof(long), 1, fp);
 fread(&fi -> nglyphs, sizeof(long), 1, fp);
 fread(&fi -> bitsdeep, sizeof(long), 1, fp);
 fread(&fi -> width, sizeof(long), 1, fp);
 fread(&fi -> resolution, sizeof(long), 1, fp);
 fread(&fi -> weight, sizeof(long), 1, fp);
 fread(&fi -> reserved1, sizeof(long), 1, fp);
 fread(&fi -> reserved2, sizeof(long), 1, fp);
 fread(&fi -> reserved3, sizeof(long), 1, fp);
 for(i = 0; i < 27; i++)
   fread(&fi -> padding[i], sizeof(long), 1, fp);
}

tfm_readfmglyphinfo(fp,gi)
FILE *fp;
fmglyphinfo *gi;
{
 unsigned char c;

 fread(&c, sizeof(unsigned char), 1, fp);
 fread(&gi -> xsize, sizeof(long), 1, fp);
 fread(&gi -> ysize, sizeof(long), 1, fp);
 fread(&gi -> xorig, sizeof(long), 1, fp);
 fread(&gi -> yorig, sizeof(long), 1, fp);
 fread(&gi -> xmove, sizeof(float), 1, fp);
 fread(&gi -> ymove, sizeof(float), 1, fp);
 fread(&gi -> gtype, sizeof(long), 1, fp);
 fread(&gi -> bitsdeep, sizeof(long), 1, fp);
}

fmfonthandle tfm_isloaded(name, sc)
char *name;
float sc;
{
 tfm_font *t;

 t = tfm.head;
 while(t) {
   if(!strcmp(name,t->fontname) && (t->realfontsize == sc))
     return((fmfonthandle)&t->fonthandle);
   t = t -> next;
 }
 return(0);
}

tfm_incref(tfh)
fmfonthandle tfh;
{
 tfm_font *t;
 long fh;

 fh = *tfh;
 t = tfm.head;
 while(t) {
   if(t->fontnum == (short)fh) {
     t->references++;
     return(0);
   }
   t = t -> next;
 }
 return(1);
}

tfm_getscale(face, sc, offset)
char *face;
float *sc;
long *offset;
{
 FILE *fp;
 int found;
 float s1,s2;
 char fontname[256];
 unsigned char size1,size2,maxsize;
 long offset1,offset2,offfound, offmax;

 /* load the font passed with the "closest" scale factor passed */
 if(*sc < 1.0) {
   *sc = 1.0;
   *offset = 0;
 }

 found = 0;
 fp = fopen(tfm.tfminfo, "r");
 if(!fp) {
   perror(tfm.tfminfo);
   exit(-1);
 }
 fontname[0] = 0;
 fscanf(fp,"%s ", fontname);
 while(!feof(fp) && !found) {
   if(!strcmp(fontname, face)) {
     found = 1;
   }
   else {
     do {
       fread(&size1, sizeof(unsigned char), 1, fp);
       fread(&offset1, sizeof(long), 1, fp);
     }
     while(size1);
     fscanf(fp,"%s ", fontname);
   }
 }
 if(!found) {
   fprintf(stderr,"TFM: Font %s not found\n", face);
   fclose(fp);
   return(0);
 }
 found = 0;
 offfound = 0;
 fread(&size1, sizeof(unsigned char), 1, fp);
 fread(&offset1, sizeof(long), 1, fp);
 maxsize = size1;
 offmax = offset1;
 s1 = (float)size1;
 while(!feof(fp) && !found && (s1 != 0.0)) {
   fread(&size2, sizeof(unsigned char), 1, fp);
   fread(&offset2, sizeof(long), 1, fp);
   s2 = (float)size2;
   if(s2 != 0.0) {
     if((s1 <= *sc) && (*sc < s2)) { /* scale factor found */
       found = (int) size1;
       offfound = offset1;
     }
     else {
       s1 = s2;
       size1 = size2;
       offset1 = offset2;
     }
     if(size2 > maxsize) {
       maxsize = size2;
       offmax = offset2;
     }
   }
   else {
     s1 = s2;
     size1 = size2;
     offset1 = offset2;
   }
 }
 fclose(fp);
 if(!found) { /* scale factor to big.. make it the max possible */
   found = (int)maxsize;
   offfound = offmax;
 }
 *sc = (float) found;
 *offset = offfound;
 return(1);
}

/*
 * $Log: tfm_support.c,v $
 * Revision 1.1  1991/09/23  18:41:26  trevor
 * - New (Compacted) font file format
 * - many bug fixes
 *
 * Revision 1.0  1991/06/28  22:52:49  trevor
 * Initial checkin
 *
 */
